<?php
/*
  $Id$ cm_sc_continue_shopping.php

  Continue Shopping 1.0
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021: Rainer Schmied - @raiwa

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  class cm_sc_continue_shopping extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_CONTENT_SC_CONTINUE_SHOPPING_';

    public function __construct() {
      parent::__construct(__FILE__);

      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';

    }

    function execute() {
      global $cart, $products, $navigation;

      $content_width = (int)MODULE_CONTENT_SC_CONTINUE_SHOPPING_CONTENT_WIDTH;

      $products = $_SESSION['cart']->get_products();
      $back = sizeof($_SESSION['navigation']->path)-2;
      $count = count($products);
      if( isset($products[$count-1]['id']) ) {
        $continueButtonId = tep_get_product_path(str_replace(strstr($products[$count-1]['id'], '{'), '', $products[$count-1]['id']));
      }

      if ( isset($continueButtonId) ) {
        $backlink = tep_href_link('index.php', 'cPath=' . $continueButtonId);
      } elseif( isset($_SERVER['HTTP_REFERER']) && (strpos($_SERVER['HTTP_REFERER'], 'checkout' ) !== false) ) {
        $backlink = tep_href_link('index.php');
      } elseif (isset($_SESSION['navigation']->path[$back])) {
        $backlink = tep_href_link($_SESSION['navigation']->path[$back]['page'], tep_array_to_string($_SESSION['navigation']->path[$back]['get'], [session_name()]));
      } else {
        $backlink = tep_href_link('index.php');
      }

      $tpl_data = [ 'group' => $this->group, 'file' => __FILE__ ];
      include 'includes/modules/content/cm_template.php';

    }

    protected function get_parameters() {
      return [
        'MODULE_CONTENT_SC_CONTINUE_SHOPPING_VERSION_INSTALLED' => [
          'title' => 'Current Version',
          'value' => '1.0',
          'desc' => 'Version info. It is read only',
          'set_func' => 'cm_sc_continue_shopping::readonly(',
        ],
        'MODULE_CONTENT_SC_CONTINUE_SHOPPING_STATUS' => [
          'title' => 'Enable Shopping Cart Continue Shopping Button',
          'value' => 'True',
          'desc' => 'Do you want to enable this module?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_CONTINUE_SHOPPING_CONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '12',
          'desc' => 'What width container should the content be shown in? (12 = full width, 6 = half width).',
          'set_func' => "tep_cfg_select_option(['12', '11', '10', '9', '8', '7', '6', '5', '4', '3', '2', '1'], ",
        ],
        'MODULE_CONTENT_SC_CONTINUE_SHOPPING_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '300',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

    public static function readonly($value) {
      return $value;
    }

  }

